import { autocompletion as j, completionKeymap as w, closeBrackets as B, closeBracketsKeymap as I } from "@codemirror/autocomplete";
import { indentWithTab as O } from "@codemirror/commands";
import { css as K } from "@codemirror/lang-css";
import { html as L } from "@codemirror/lang-html";
import { json as R } from "@codemirror/lang-json";
import { yaml as V } from "@codemirror/lang-yaml";
import { syntaxHighlighting as A, defaultHighlightStyle as z, indentOnInput as J, bracketMatching as v } from "@codemirror/language";
import { linter as P } from "@codemirror/lint";
import { StateEffect as U } from "@codemirror/state";
import { EditorView as d, highlightSpecialChars as W, keymap as a, placeholder as q, lineNumbers as D } from "@codemirror/view";
import { ref as G, watch as m, onBeforeUnmount as Q, toValue as t, computed as X } from "vue";
import { customTheme as Y } from "../themes/index.js";
import { variables as Z } from "./variables.js";
const u = (e) => "provider" in e && !!t(e.provider), _ = {
  key: "Mod-a",
  run: (e) => (e.dispatch({
    selection: { anchor: 0, head: e.state.doc.length },
    scrollIntoView: !1
  }), !0)
}, de = (e) => {
  const i = G(null);
  m(
    e.codeMirrorRef,
    () => {
      var o;
      (o = i.value) == null || o.destroy(), l();
    },
    { immediate: !0 }
  ), Q(() => {
    var o;
    return (o = i.value) == null ? void 0 : o.destroy();
  });
  function l() {
    if (e.codeMirrorRef.value) {
      const o = u(e) ? t(e.provider) : null, h = x({
        ...s.value,
        provider: o
      });
      i.value = new d({
        parent: e.codeMirrorRef.value,
        extensions: h
      }), u(e) || n(t(e.content));
    }
  }
  const s = X(() => ({
    onChange: e.onChange,
    onBlur: e.onBlur,
    onFocus: e.onFocus,
    disableTabIndent: t(e.disableTabIndent),
    language: t(e.language),
    classes: t(e.classes),
    readOnly: t(e.readOnly),
    lineNumbers: t(e.lineNumbers),
    withVariables: t(e.withVariables),
    disableEnter: t(e.disableEnter),
    disableCloseBrackets: t(e.disableCloseBrackets),
    withoutTheme: t(e.withoutTheme),
    lint: t(e.lint),
    additionalExtensions: t(e.extensions),
    placeholder: t(e.placeholder)
  }));
  m(
    () => u(e) ? t(e.provider) : null,
    () => {
      var o;
      u(e) && ((o = i.value) == null || o.destroy(), l());
    }
  ), m(
    s,
    () => {
      if (i.value) {
        const o = u(e) ? t(e.provider) : null, h = x({
          ...s.value,
          provider: o
        });
        i.value.dispatch({
          effects: U.reconfigure.of(h)
        });
      } else
        return;
    },
    { immediate: !0 }
  );
  const n = (o = "") => {
    i.value && i.value.state.doc.toString() !== o && i.value.dispatch({
      changes: {
        from: 0,
        to: i.value.state.doc.length,
        insert: o
      },
      selection: {
        anchor: Math.min(
          i.value.state.selection.main.anchor,
          o.length
        )
      }
    });
  };
  return m(
    () => t(e.content),
    () => {
      u(e) || n(t(e.content));
    },
    { immediate: !0 }
  ), {
    /** Replaces the current content with the given value. */
    setCodeMirrorContent: n,
    /** Codemirror instance */
    codeMirror: i
  };
}, y = {
  html: L,
  json: R,
  yaml: V,
  css: K
};
function x({
  onChange: e,
  onBlur: i,
  onFocus: l,
  provider: s,
  language: n,
  classes: o = [],
  readOnly: h = !1,
  lineNumbers: E = !1,
  withVariables: k = !1,
  disableEnter: C = !1,
  disableCloseBrackets: M = !1,
  disableTabIndent: S = !1,
  withoutTheme: T = !1,
  lint: H = !1,
  additionalExtensions: N = [],
  placeholder: g
}) {
  const r = [
    W(),
    A(z, { fallback: !0 }),
    d.theme({
      ".cm-line": {
        lineHeight: "20px"
      },
      ".cm-gutterElement": {
        lineHeight: "20px"
      },
      ".cm-tooltip": {
        border: "1px solid #f5c6cb",
        fontSize: "12px"
      },
      ".cm-tooltip-lint": {
        backgroundColor: "#ffffff"
      },
      ".cm-diagnostic-error": {
        borderLeft: "0",
        color: "#dc1b19"
      }
    }),
    // Listen to updates
    d.updateListener.of((c) => {
      c.docChanged && (e == null || e(c.state.doc.toString()));
    }),
    d.domEventHandlers({
      blur: (c, f) => {
        i == null || i(f.state.doc.toString());
      },
      focus: (c, f) => {
        l == null || l(f.state.doc.toString());
      }
    }),
    // Add Classes
    d.editorAttributes.of({ class: o.join(" ") }),
    ...N
  ];
  if (s && r.push(s), T || r.push(Y), h ? r.push(d.editable.of(!1)) : (r.push(
    J(),
    v(),
    j(),
    a.of([...w, _]),
    v()
  ), M || r.push(B(), a.of([...I])), S ? r.push(
    a.of([
      {
        key: "Tab",
        run: () => !1,
        // Prevent default Tab behavior
        shift: () => !1
        // Prevent default Shift+Tab behavior
      }
    ])
  ) : r.push(a.of([O]))), g && r.push(q(g)), n && y[n] && r.push(y[n]()), H && n === "json") {
    const c = P((f) => {
      const b = [];
      try {
        JSON.parse(f.state.doc.toString());
      } catch (p) {
        p instanceof Error && b.push({
          from: 0,
          to: f.state.doc.length,
          severity: "error",
          message: p.message
        });
      }
      return b;
    });
    r.push(c);
  }
  return E && r.push(D()), k && r.push(Z()), C && r.push(
    a.of([
      {
        key: "Enter",
        run: () => !0
      },
      {
        key: "Ctrl-Enter",
        mac: "Cmd-Enter",
        run: () => !0
      },
      {
        key: "Shift-Enter",
        run: () => !0
      }
    ])
  ), r;
}
export {
  de as useCodeMirror
};
